PPATH - Prime Path
The ministers of the cabinet were quite upset by the
message from the Chief of Security stating that they
would all have to change the four-digit room numbers
on their offices.
— It is a matter of security to change such things
every now and then, to keep the enemy in the dark.
— But look, I have chosen my number 1033 for good
reasons. I am the Prime minister, you know!
— I know, so therefore your new number 8179 is also
a prime. You will just have to paste four new
digits over the four old ones on your office door.
— No, it's not that simple. Suppose that I change the
first digit to an 8, then the number will read 8033
which is not a prime!
— I see, being the prime minister you cannot stand
having a non-prime number on your door even for a
few seconds.
— Correct! So I must invent a scheme for going from
1033 to 8179 by a path of prime numbers where
only one digit is changed from one prime to the
next prime.
Now, the minister of finance, who had been eavesdropping,
intervened.
— No unnecessary expenditure, please! I happen to
know that the price of a digit is one pound.
— Hmm, in that case I need a computer program to
minimize the cost. You don't know some very cheap
software gurus, do you?
— In fact, I do. You see, there is this programming
contest going on...
Help the prime minister to find the cheapest prime path between any two given four-digit primes! The first digit must be nonzero, of course. Here is a solution in the case above.
1033 1733 3733 3739 3779 8779 8179The cost of this solution is 6 pounds. Note that the digit 1 which got pasted over in step 2 can not be reused in the last step – a new 1 must be purchased.
Input
One line with a positive number: the number of test cases (at most 100). Then for each test case, one line with two numbers separated by a blank. Both numbers are four-digit primes (without leading zeros).
Output
One line for each case, either with a number stating the minimal cost or containing the word Impossible.
Example
Input: 3 1033 8179 1373 8017 1033 1033 Output: 6 7 0
hide comments
thirupathireddy:
2015-09-17 07:39:01
nice one on bfs.............
|
|
ALi Ibrahim:
2015-08-01 22:22:17
Nice problem, first Accepted :)
|
|
sHaShAnK sHeKhAr:
2015-05-21 11:21:23
Nice question, can be solved from both Dijkstra and simple BFS :) since cost of each edge is 1($). |
|
i_am_looser:
2015-05-08 06:55:03
Literally very nice problem : )
|
|
Shubham Bansal:
2015-03-29 14:20:18
a very nice problem... |
|
pandu ranga rao:
2015-03-06 21:36:40
Nice QN..! |
|
Anubhav Gupta:
2015-02-11 21:46:28
Awesome question!! |
|
epsilon:
2015-01-24 12:01:02
my 50th on spoj...........till now it's
|
|
fanatique:
2015-01-08 14:42:37
good one... :)
|
|
Mitch Schwartz:
2015-01-02 08:55:39
"Piece of Cake!! Simple [hint] it is!!! Skilled implementation is the key though :P"
|
Added by: | overwise |
Date: | 2007-10-02 |
Time limit: | 2s |
Source limit: | 50000B |
Memory limit: | 1536MB |
Cluster: | Cube (Intel G860) |
Languages: | All except: ERL JS-RHINO NODEJS PERL6 VB.NET |
Resource: | ACM ICPC NWERC 2006 |